package Birth;

import com.hp.hpl.mesa.rdf.jena.common.ErrorHelper;
import com.hp.hpl.mesa.rdf.jena.common.PropertyImpl;
import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;

import com.hp.hpl.mesa.rdf.jena.model.Model;
import com.hp.hpl.mesa.rdf.jena.model.Resource;
import com.hp.hpl.mesa.rdf.jena.model.Property;
import com.hp.hpl.mesa.rdf.jena.model.RDFException;
import ABC.*;

public class Birth extends ABCVocab {

    // next free error code = 2
    public Birth() {
      this.properties = new Property[4];

      properties[0] = mother;
      properties[1] = father;
      properties[2] = midwife;
      properties[3] = obstetrician;
    }
    protected static final String uri =
        "http://somenet.com/Birth#";

/** returns the URI for this schema
 * @return the URI for this schema
 */
    public static String getURI()
    {
        return uri;
    }

           static final String    nBirth = "BirthEvent";
    public static       Resource  BirthEvent = null;
           static final String    nParenting = "Parenting";
    public static       Resource  Parenting = null;
           static final String    nDelivery = "Delivery";
    public static       Resource  Delivery = null;

           static final String    nmother = "mother";
    public static       Property  mother;
           static final String    nfather = "father";
    public static       Property  father;
           static final String    nmidwife = "midwife";
    public static       Property  midwife;
           static final String    nobstetrician = "obstetrician";
    public static       Property  obstetrician;

    static {
        try {

          BirthEvent = new ResourceImpl(uri+nBirth);
          Parenting = new ResourceImpl(uri+nParenting);
          Delivery = new ResourceImpl(uri+nDelivery);

          mother = new mother(uri, nmother);
          father = new father(uri, nfather);
          midwife = new midwife(uri, nmidwife);
          obstetrician = new obstetrician(uri, nobstetrician);

        } catch (RDFException e) {
            ErrorHelper.logInternalError("Birth", 1, e);
        }
    }
}