import java.awt.*;
import java.util.*;
import java.awt.event.*;

public class CanvasPanModule extends Module {
  int oldx;
  int oldy;

  public CanvasPanModule(Application app) {
    super(app);
    canvas.registerModule(this,canvas.MouseMotionEvent);
    canvas.registerModule(this,canvas.MouseEvent);
    canvas.registerModule(this,canvas.CanvasEvent);
  }

  public void mousePressed(MouseEvent e) {
    if(canvas.getMode() == canvas.PAN) {
      oldx = e.getPoint().x;
      oldy = e.getPoint().y;
    }
  }

  public void mouseDragged(MouseEvent e) {
    if(canvas.getMode() == canvas.PAN) {
      HashMap resourceNodes = canvas.nodesManager.resourceNodes;
      Iterator iter = resourceNodes.values().iterator();
      int dx = e.getPoint().x - oldx;
      int dy = e.getPoint().y - oldy;
      while(iter.hasNext()) {
        NodeRenderer renderer = ((ResourceNode)iter.next()).getRenderer();
        renderer.setPosition(renderer.getPosition().x + dx,
          renderer.getPosition().y + dy);
      }
      oldx += dx;
      oldy += dy;
      canvas.dirty = true;
    }
  }

  public void modeChanged(int oldMode, int newMode) {
    if(oldMode == newMode) return;
    if(newMode == canvas.PAN) {
      canvas.setCursor(new Cursor(Cursor.MOVE_CURSOR));
    }
  }
}