import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import java.lang.*;
import java.util.*;

public class ColorManagerModule extends Module implements
ActionListener {

  Color defaultNodeColor;
  Color violatedColor;
  Color selectedColor;
  Color floatingColor;
  Color disabledColor;
  HashMap uriToColor;

  static boolean added = false;

  public ColorManagerModule(Application app) {
    super(app);

    uriToColor = new HashMap();
    defaultNodeColor = Color.blue;

    if(added) return;
    added = true;
    JMenuBar menubar = app.mainWindow.getJMenuBar();
    JMenu optionMenu = null;
    for(int i=0; i<menubar.getMenuCount(); i++) {
      if(menubar.getMenu(i).getText().equals("Option"))
        optionMenu = menubar.getMenu(i);
    }
    JMenuItem menuItem = new JMenuItem("Colors");
    menuItem.setActionCommand("Colors");
    menuItem.addActionListener(this);
    optionMenu.addSeparator();
    optionMenu.add(menuItem);
  }

  public void actionPerformed(ActionEvent e) {
    String actionCommand = e.getActionCommand();
    if(actionCommand.equals("Colors")) {
      ColorManagerDialog win = new ColorManagerDialog(this.app);
      win.setVisible(true);
      canvas.dirty = true;
    }
  }

  public void resetColor() {
    Iterator iter = canvas.nodesManager.resourceNodes.values().iterator();
    while(iter.hasNext()) {
      ResourceNode resourceNode = (ResourceNode)iter.next();
      resourceNode.getRenderer().setColor(defaultNodeColor);
    }
    Iterator keys = uriToColor.keySet().iterator();
    while(keys.hasNext()) {
      String uri = (String)keys.next();
      Iterator testSet  = canvas.nodesManager.nodesSelector.selectNodeByColor(defaultNodeColor).iterator();
      HashMap resourceNodes = canvas.nodesManager.resourceNodes;
      while(testSet.hasNext()) {
        TypedResource test = (TypedResource)testSet.next();
        if(test.myTypeURI().equals(uri)) {
          ResourceNode rn = (ResourceNode)resourceNodes.get(test);
          rn.getRenderer().setColor((Color)uriToColor.get(uri));
        }
      }
    }
  }
}