import java.util.*;
import java.awt.event.*;
import javax.swing.*;

public class EdgeDeletionModule extends Module {


  boolean needConfirmation;

  public EdgeDeletionModule(Application app) {
    super(app);

    needConfirmation(false);
    canvas.edgesManager.registerModule(this,canvas.KeyEvent);
  }

  public void keyPressed(KeyEvent e) {
    if(canvas.getMode() == canvas.SELECT) {
      if(e.getKeyCode() == e.VK_DELETE) {
        Set target = canvas.edgesManager.edgeSelector.getSelectedSet();
        if(!target.isEmpty() && needConfirmation &&
          JOptionPane.showConfirmDialog(app.mainWindow,
            "Are you sure you want to delete the nodes?") ==
              JOptionPane.NO_OPTION ) {
          return;
        }

        Iterator iter = target.iterator();
        while(iter.hasNext()) {
          PropertyEdge propertyEdge = (PropertyEdge)iter.next();
          propertyEdge.sub.removeProperty(propertyEdge,true);
          propertyEdge.obj.removeProperty(propertyEdge,false);
        }
        deleteProperties(target);
        canvas.nodesManager.nodesSelector.deselectAll();
        canvas.dirty = true;
      }
    }
  }

  public void deleteProperties(Set target) {
    canvas.edgesManager.propertyEdges.removeAll(target);
  }
  public void deleteProperty(Object target) {
    canvas.edgesManager.propertyEdges.remove(target);
  }
  public void needConfirmation(boolean n) {  needConfirmation = n; }

}