import java.awt.*;
import java.awt.geom.*;

public interface EdgeRenderer {
  public void render(Graphics2D g2);
  public boolean nearStartPoint(Point2D pt);
  public boolean nearEndPoint(Point2D pt);
  public void setColor(Color c);
  public void setTextColor(Color c);
  public Color getColor();
  public Point2D getP1();
  public Point2D getP2();
  public void setP1(Point2D p1);
  public void setP2(Point2D p2);
  public NodeRenderer getSub();
  public NodeRenderer getObj();
  public void setSub(NodeRenderer sub);
  public void setObj(NodeRenderer obj);
  public Rectangle2D getSelectionBox();
}