
/**
 * Title:        ABC API
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author David Lin
 * @version 1.0
 */

import com.hp.hpl.mesa.rdf.jena.common.ErrorHelper;
import com.hp.hpl.mesa.rdf.jena.common.PropertyImpl;
import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;

import com.hp.hpl.mesa.rdf.jena.model.Model;
import com.hp.hpl.mesa.rdf.jena.model.Resource;
import com.hp.hpl.mesa.rdf.jena.model.Property;
import com.hp.hpl.mesa.rdf.jena.model.RDFException;

public class GUI {

    // next free error code = 2

    protected static final String uri =
        "http://GUI#";

/** returns the URI for this schema
 * @return the URI for this schema
 */
    public static String getURI()
    {
        return uri;
    }

           static final String    natX = "atX";
    public static       Property  atX;
           static final String    natY = "atY";
    public static       Property  atY;
           static final String    nlibrary = "library";
    public static       Property  library;
           static final String    nlibraryNameSpace = "libraryNameSpace";
    public static       Property  libraryNameSpace;
           static final String    nlibrarySchema = "librarySchema";
    public static       Property  librarySchema;
           static final String    nlibraryTabName = "libraryTabName";
    public static       Property  libraryTabName;
           static final String    ndefaultWorkingDirectory = "defaultWorkingDirectory";
    public static       Property  defaultWorkingDirectory;


    static {
        try {

          atX = new PropertyImpl(uri,natX);
          atY = new PropertyImpl(uri,natY);
          library = new PropertyImpl(uri,nlibrary);
          libraryNameSpace = new PropertyImpl(uri,nlibraryNameSpace);
          librarySchema = new PropertyImpl(uri,nlibrarySchema);
          libraryTabName = new PropertyImpl(uri,nlibraryTabName);
          defaultWorkingDirectory = new PropertyImpl(uri,ndefaultWorkingDirectory);

        } catch (RDFException e) {
            ErrorHelper.logInternalError("ABC", 1, e);
        }
    }
}