import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.lang.reflect.*;
import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;
import ABC.*;
import java.util.*;
import java.io.*;

public class NodesDeletionModule extends Module {

  boolean needConfirmation;
  public NodesDeletionModule(Application app) {
    super(app);

    needConfirmation(false);
    canvas.nodesManager.registerModule(this,canvas.KeyEvent);
  }

  public void needConfirmation(boolean n) {
    needConfirmation = n;
  }

  public void removeNode(Resource node) {
    ResourceNode obj =
     (ResourceNode)canvas.nodesManager.resourceNodes.get(node);
    Set propertySet = obj.getAllProperties();
    canvas.edgesManager.edgeDeletor.deleteProperties(propertySet);
    // remove node
    canvas.nodesManager.resourceNodes.remove(node);
    // remove stmt from model
    canvas.modelManager.removeStmtAsSub(node);
    canvas.modelManager.removeStmtAsObj(node);
    canvas.dirty = true;
  }

  public void keyPressed(KeyEvent e) {
    if(canvas.getMode() == canvas.SELECT) {
      if(e.getKeyCode() == e.VK_DELETE) {
        Set target = canvas.nodesManager.nodesSelector.getSelectedSet();
        if(!target.isEmpty() && needConfirmation &&
          JOptionPane.showConfirmDialog(app.mainWindow,
            "Are you sure you want to delete the nodes?") ==
              JOptionPane.NO_OPTION ) {
          return;
        }

        Iterator keys = target.iterator();
        while(keys.hasNext()) {
          Resource key = (Resource)keys.next();
          // remove edges
          ResourceNode obj =
            (ResourceNode)canvas.nodesManager.resourceNodes.get(key);
          Set propertySet = obj.getAllProperties();
          canvas.edgesManager.edgeDeletor.deleteProperties(propertySet);
          // remove node
          canvas.nodesManager.resourceNodes.remove(key);
          // remove stmt from model
          canvas.modelManager.removeStmtAsSub(key);
          canvas.modelManager.removeStmtAsObj(key);
        }

        canvas.nodesManager.nodesSelector.deselectAll();
        canvas.dirty = true;
      }
    }
  }
}