import javax.swing.*;          //This is the final package name.
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import java.lang.reflect.*;

import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;

import ABC.*;

public class PropertiesPane extends JPanel implements ActionListener{

  Application app;
  AddPropertyDialog parent;

  public String tabName = "";
  public int classesToLoad = 0;

  HashMap textToKey;
  HashMap textTobuttons;

  public PropertiesPane(AddPropertyDialog p, Application application,
  String tabName, HashMap textToKeyMapping) {

    super();
    parent = p;
    app = application;
    textToKey = new HashMap(textToKeyMapping);
    textTobuttons = new HashMap();

    this.setLayout(new GridLayout(6,2,2,2));

    Iterator keys = textToKey.keySet().iterator();
    while(keys.hasNext()) {
      String key = (String)keys.next();
      JButton button = new JButton(key);
      button.setActionCommand((String)textToKey.get(key));
      button.addActionListener(this);
      textTobuttons.put(key,button);
      this.add(button);
    }
  }

  public void ApplyFilter(Set belongset) {
    try {
      ResourceLibManager lib = app.resourceWindow.resourceLibManager;
      Iterator labels = this.textToKey.keySet().iterator();
      Iterator iter = belongset.iterator();
      while(labels.hasNext()) {
        String label = ((String)labels.next());
        String uriName = ((String)textToKey.get(label));
   //     System.out.println("&&&"+uriName);
        ABCProperty p = (ABCProperty)lib.uriNameToProperty.get(uriName);
        if(!p.inDomain(belongset)) {
          JButton button = (JButton)this.textTobuttons.get(label);
          button.setEnabled(false);
        }
      }
    } catch(Exception e) { e.printStackTrace(); }
  }

  public void RemoveFilter() {
    Iterator iter = this.textTobuttons.values().iterator();
    while(iter.hasNext()) {
      JButton button = (JButton)iter.next();
      button.setEnabled(true);
    }
  }

  public void actionPerformed(ActionEvent e) {
    String actionCommand = e.getActionCommand();
    ResourceLibManager lib = app.resourceWindow.resourceLibManager;
    Property p = (Property)lib.uriNameToProperty.get(actionCommand);
    if(p!=null) {
      app.mainWindow.docCanvas.edgesManager.edgeCreator.
        addPropertyToSelected(p);
      parent.setVisible(false);
    }
  }
}