import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import ABC.*;
import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;

public class ResourceFactory {

  public String parentURI;
  public String selfURI;
  HashSet belongSet;

  public ResourceFactory(String s, String p, ResourceLibManager lib) {
    selfURI = s;
    parentURI = p;
    belongSet = new HashSet();
    belongSet.add(selfURI);
    if(parentURI != null && parentURI.length() != 0) { // has a parent
      ResourceFactory parent =
        (ResourceFactory)lib.uriNameToResourceFactory.get(parentURI);
      belongSet.addAll(parent.belongsTo());
    }
  }

  public Resource createInstance(String uri, Model m) {
    try {
    return (new TypedResource(uri,m,this)).
              addProperty(RDF.type,new ResourceImpl(selfURI));
    }catch(Exception e) { return null; }
  }

  public Resource createInstance(Resource rec, Model m) {
    try {
    return (new TypedResource(rec,m,this)).
              addProperty(RDF.type,new ResourceImpl(selfURI));
    }catch(Exception e) { return null; }
  }

  public Set belongsTo() { return this.belongSet; }

  public String toString() {
    return "<" + selfURI + "," + parentURI + ">";
  }

}