import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.mem.ModelMem;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;
import java.awt.*;
import java.lang.*;
import java.util.*;

public class ResourceNode {

  private Vector propertiesAsSubject;
  private Vector propertiesAsObject;
  private NodeRenderer renderer;
  Resource data;

  public ResourceNode(Resource d, NodeRenderer r) {
    data = d;
    renderer = r;
    propertiesAsSubject = new Vector();
    propertiesAsObject = new Vector();
  }

  public void addProperty(PropertyEdge pred, boolean asSubject) {
    if(asSubject) propertiesAsSubject.add(pred);
    else propertiesAsObject.add(pred);
  }

  public void removeProperty(PropertyEdge pred, boolean asSubject) {
    if(asSubject) propertiesAsSubject.remove(pred);
    else propertiesAsObject.remove(pred);
  }

  public Set getAllProperties() {
    HashSet toReturn = new HashSet();
    toReturn.addAll(this.propertiesAsObject);
    toReturn.addAll(this.propertiesAsSubject);
    return toReturn;
  }

  public void render(Graphics2D g2) {
    renderer.render(g2);
  }

  public NodeRenderer getRenderer() {
    return renderer;
  }
}