import javax.swing.*;          //This is the final package name.
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import java.lang.reflect.*;

import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;

public class ResourcePane extends JPanel implements ActionListener{

  Application app;
  ResourceLibManager libManager;

  String packageName = "";
  public String tabName = "";
  public int classesToLoad = 0;
  boolean loadingSuccessful = false;

  Class vocab;
  HashMap textToKey;

  public ResourcePane(HashMap textToKeyMapping, String nsURI, String tName, ResourceLibManager t) {
    libManager = t;
    app = libManager.app;

    classesToLoad = textToKeyMapping.size();
    tabName = tName;
    if(tName==null)
      tabName = libManager.parent.registerURIName(nsURI);
    textToKey = new HashMap(textToKeyMapping);

    if(tabName.length() == 0) {
      return; // user cancelled;
    }

//    vocab = Class.forName(packageName+"."+packageName);

    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    this.setLayout(gridbag);
    c.fill = GridBagConstraints.BOTH;
    c.insets = new Insets(1,1,1,1);  //padding
    c.weightx = 0.5;
    c.gridx = 0;
    c.gridy = 0;

    Iterator keys = textToKeyMapping.keySet().iterator();
    while(keys.hasNext()) {
      String key = (String)keys.next();
      JButton button = new JButton(key);
      button.setActionCommand((String)textToKeyMapping.get(key));
      button.addActionListener(this);
      gridbag.setConstraints(button, c);
      this.add(button);
      c.gridy++;
    } // end for loop for reading classes

    c.gridy++;
    c.weighty=0.5;
    JLabel spacer = new JLabel("");
    gridbag.setConstraints(spacer,c);
    this.add(spacer);

    if(this.textToKey.size()!=0)
      libManager.parent.tabbedPane.addTab(tabName,null,this);

//    app.mainWindow.addPropertyDialog.addTab(app,tabName,vocab);
  }

  public ResourcePane(BufferedReader reader, ResourceWindow t) { }

  public void actionPerformed(ActionEvent e) {
    String actionCommand = e.getActionCommand();
    ResourceFactory factory =
      (ResourceFactory)libManager.uriNameToResourceFactory.get(actionCommand);
    if(factory!=null) {
      app.mainWindow.docCanvas.nodesManager.nodeCreator.createNode(factory);
    }
    else {
      app.showErrorMessage("Error: this button is not link to any resource factory");
    }
  }
}