import javax.swing.*;
import java.beans.*; //Property change stuff
import java.awt.*;
import java.awt.event.*;
import java.net.*;

class ResourceURIInputDialog extends JDialog {
    private String typedText = null;

    private JOptionPane optionPane;

    public String getText() {
      return typedText;
    }

    public void clearText() {
      typedText = null;
    }

    public ResourceURIInputDialog(JFrame aFrame) {
        super(aFrame, true);

        setTitle("Additonal Data...");

        final String msgString1 = "Resource URI: (blank for anonymous resource)";
        final JTextField textField1 = new JTextField(30);
        Object[] array = {msgString1, textField1};

        final String btnString1 = "Create";
        final String btnString2 = "Cancel Adding";
        Object[] options = {btnString1, btnString2};

        optionPane = new JOptionPane(array,
                                    JOptionPane.QUESTION_MESSAGE,
                                    JOptionPane.YES_NO_OPTION,
                                    null,
                                    options,
                                    options[0]);
        setContentPane(optionPane);
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent we) {
                    optionPane.setValue(new Integer(
                                        JOptionPane.CLOSED_OPTION));
            }
        });

        textField1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                optionPane.setValue(btnString1);
            }
        });

        optionPane.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
                String prop = e.getPropertyName();

                if (isVisible()
                 && (e.getSource() == optionPane)
                 && (prop.equals(JOptionPane.VALUE_PROPERTY) ||
                     prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
                    Object value = optionPane.getValue();

                    if (value == JOptionPane.UNINITIALIZED_VALUE) {
                        return;
                    }

                    optionPane.setValue(
                            JOptionPane.UNINITIALIZED_VALUE);

                    if (value.equals(btnString1)) {
                      try{
                        typedText = textField1.getText();
                        URL formatTester = new URL("http://"+typedText);
                        textField1.setText("");
                        setVisible(false);
                      } catch(Exception ee) {
                        textField1.selectAll();
                        JOptionPane.showMessageDialog(
                                            ResourceURIInputDialog.this,
                                            "Sorry, \"" + typedText + "\" "
                                            + "isn't a valid URL.\n",
                                            "Error",
                                            JOptionPane.ERROR_MESSAGE);
                      }
                    } else {
                        typedText = null;
                        setVisible(false);
                    }
                }
            }
        });
        this.pack();
    }
/*    public void setVisible(boolean flag) {
      this.clearText();
      super.setVisible(flag);
    } */

}
