package ABC;

/**
 * Title:        ABC API
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author David Lin
 * @version 1.0
 */

import com.hp.hpl.mesa.rdf.jena.common.ErrorHelper;
import com.hp.hpl.mesa.rdf.jena.common.PropertyImpl;
import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;

import com.hp.hpl.mesa.rdf.jena.model.Model;
import com.hp.hpl.mesa.rdf.jena.model.Resource;
import com.hp.hpl.mesa.rdf.jena.model.Property;
import com.hp.hpl.mesa.rdf.jena.model.RDFException;

public class ABC extends ABCVocab{

    public ABC() {
      this.properties = new Property[20];

      properties[0] = proceeds;
      properties[1] = follows;
      properties[2] = isPartOf;
      properties[3] = isSubEventOf;
      properties[4] = contains;
      properties[5] = inContext;
      properties[6] = phaseOf;
      properties[7] = hasRealization;
      properties[8] = hasCopy;
      properties[9] = involves;
      properties[10] = hasPatient;
      properties[11] = usesTool;
      properties[12] = hasResult;
      properties[13] = destroys;
      properties[14] = creates;
      properties[15] = hasAction;
      properties[16] = hasPresence;
      properties[17] = hasParticipant;
      properties[18] = atTime;
      properties[19] = inPlace;

    }
    protected static final String uri =
        "http://metadata.net/harmony#";

/** returns the URI for this schema
 * @return the URI for this schema
 */
//    public static propertiesArray

    public static String getURI()
    {
        return uri;
    }

           static final String    nEntity = "Entity";
    public static       Resource  Entity = null;
           static final String    nTemporality = "Temporality";
    public static       Resource  Temporality = null;
           static final String    nActuality = "Actuality";
    public static       Resource  Actuality = null;
           static final String    nAbstraction = "Abstraction";
    public static       Resource  Abstraction = null;
           static final String    nArtifact = "Artifact";
    public static       Resource  Artifact = null;
           static final String    nEvent = "Event";
    public static       Resource  Event = null;
           static final String    nSituation = "Situation";
    public static       Resource  Situation = null;
           static final String    nAction = "Action";
    public static       Resource  Action = null;
           static final String    nAgent = "Agent";
    public static       Resource  Agent = null;
           static final String    nWork = "Work";
    public static       Resource  Work = null;
           static final String    nManifestation = "Manifestation";
    public static       Resource  Manifestation = null;
           static final String    nItem = "Item";
    public static       Resource  Item = null;
           static final String    nTime = "Time";
    public static       Resource  Time = null;
           static final String    nPlace = "Place";
    public static       Resource  Place = null;


           static final String    nproceeds = "proceeds";
    public static       Property  proceeds;
           static final String    nfollows = "follows";
    public static       Property  follows;

           static final String    nisPartOf = "isPartOf";
    public static       Property  isPartOf;

           static final String    nisSubEventOf = "isSubEventOf";
    public static       Property  isSubEventOf;
           static final String    ncontains = "contains";
    public static       Property  contains;
           static final String    ninContext = "inContext";
    public static       Property  inContext;
           static final String    nphaseOf = "phaseOf";
    public static       Property  phaseOf;
           static final String    nhasRealization = "hasRealization";
    public static       Property  hasRealization;
           static final String    nhasCopy = "hasCopy";
    public static       Property  hasCopy;
           static final String    ninvolves = "involves";
    public static       Property  involves;
           static final String    nhasPatient = "hasPatient";
    public static       Property  hasPatient;
           static final String    nusesTool = "usesTool";
    public static       Property  usesTool;
           static final String    nhasResult = "hasResult";
    public static       Property  hasResult;
           static final String    ndestroys = "destroys";
    public static       Property  destroys;
           static final String    ncreates = "creates";
    public static       Property  creates;
           static final String    nhasAction = "hasAction";
    public static       Property  hasAction;
           static final String    nhasPresence = "hasPresence";
    public static       Property  hasPresence;

           static final String    nhasParticipant = "hasParticipant";
    public static       Property  hasParticipant;

           static final String    natTime = "atTime";
    public static       Property  atTime;
           static final String    ninPlace = "inPlace";
    public static       Property  inPlace;

    static {
        try {

          Entity = new ResourceImpl(uri+nEntity);
          Temporality = new ResourceImpl(uri+nTemporality);
          Actuality = new ResourceImpl(uri+nActuality);
          Abstraction = new ResourceImpl(uri+nAbstraction);
          Artifact = new ResourceImpl(uri+nArtifact);
          Event = new ResourceImpl(uri+nEvent);
          Situation = new ResourceImpl(uri+nSituation);
          Action = new ResourceImpl(uri+nAction);
          Agent = new ResourceImpl(uri+nAgent);
          Work = new ResourceImpl(uri+nWork);
          Manifestation = new ResourceImpl(uri+nManifestation);
          Item = new ResourceImpl(uri+nItem);
          Time = new ResourceImpl(uri+nTime);
          Place = new ResourceImpl(uri+nPlace);

          proceeds = new proceeds(uri, nproceeds);
          follows = new follows(uri, nfollows);
          isSubEventOf = new isSubEventOf(uri, nisSubEventOf);
          contains = new contains(uri, ncontains);
          inContext = new inContext(uri, ninContext);
          phaseOf = new phaseOf(uri, nphaseOf);
          hasRealization = new hasRealization(uri, nhasRealization);
          hasCopy = new hasCopy(uri, nhasCopy);
          involves = new involves(uri, ninvolves);
          hasPatient = new hasPatient(uri, nhasPatient);
          usesTool = new usesTool(uri, nusesTool);
          hasResult = new hasResult(uri, nhasResult);
          destroys = new destroys(uri, ndestroys);
          creates = new creates(uri, ncreates);
          hasAction = new hasAction(uri, nhasAction);
          hasPresence = new hasPresence(uri, nhasPresence);
          atTime = new atTime(uri, natTime);
          inPlace = new inPlace(uri, ninPlace);
          hasParticipant = new hasParticipant(uri,nhasParticipant);
          isPartOf = new isPartOf(uri,nisPartOf);

        } catch (RDFException e) {
            ErrorHelper.logInternalError("ABC", 1, e);
        }
    }
}