package ABC;

import com.hp.hpl.mesa.rdf.jena.common.ResourceImpl;
import com.hp.hpl.mesa.rdf.jena.model.*;
import com.hp.hpl.mesa.rdf.jena.vocabulary.*;
import java.lang.*;

public class Item extends Artifact {
  public Item() { super(); }
  public Item(String s, Model m) throws RDFException{ super(s,m); type(ABC.Item);}
  public Item(Model m) throws RDFException{ super(m); type(ABC.Item);}
  public Item(String s) throws RDFException { super(s); }
  public Item(Resource r, Model m) throws RDFException { super(r,m); type(ABC.Item); }

  public static ItemFactory factory = new ItemFactory();

  public void setType() throws RDFException {
    type(ABC.Item);
  }

  public static class ItemFactory{
    public ItemFactory() {}
    public ResourceImpl create(String s, Model m) throws RDFException{ return new Item(s,m); }
    public ResourceImpl create(Model m) throws RDFException{ return new Item(m); }
    public ResourceImpl create(String s) throws RDFException { return new Item(s); }
    public ResourceImpl create(Resource r, Model m) throws RDFException { return new Item(r,m); }
  }
}