package ABC;

import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.model.*;

public class typedProperty extends PropertyImpl {

  protected String[] domainClasses;
  protected String[] rangeClasses;

  public typedProperty(String uri) throws RDFException { super(uri); }
  public typedProperty(String nameSpace, String localName)
      throws RDFException { super(nameSpace,localName); }

  public boolean checkInDomain(RDFNode s) throws Exception {
    return checkClasses(domainClasses,s);
  }
  public boolean checkInRange(RDFNode p)  throws Exception {
    return checkClasses(rangeClasses,p);
  }
  private boolean checkClasses(String[] classes, RDFNode target) throws Exception {
    for(int i=0; i< classes.length; i++) {
      Class d = Class.forName(classes[i]);
      if(d.isInstance(target))
        return true;
    }
    return false;
  }

}