import com.hp.hpl.mesa.rdf.jena.common.*;
import com.hp.hpl.mesa.rdf.jena.model.*;
import java.util.*;

public class TypedProperty extends PropertyImpl
implements ABC.ABCProperty {

  String selfURI;
  String parentURI;
  ResourceLibManager lib;
  protected HashSet domainTypeURIs;
  protected HashSet rangeTypeURIs;

  public TypedProperty(String selfURI, String parentURI, ResourceLibManager lib)
  throws RDFException{
    super(selfURI);
    this.selfURI = selfURI;
    this.parentURI = parentURI;
    this.lib = lib;
    domainTypeURIs = new HashSet();
    rangeTypeURIs = new HashSet();
  }

  public void addDomain(String domainURI) {  domainTypeURIs.add(domainURI); }
  public void addRange(String rangeURI) { rangeTypeURIs.add(rangeURI); }

  public boolean domainChecking() { return (domainTypeURIs.size()!=0); }
  public boolean rangeChecking() { return (rangeTypeURIs.size()!=0); }

  public boolean inDomain(Set belongSet) {
    if(!domainChecking()) return true; // not doing domain checking
    Iterator iter = belongSet.iterator();
    while(iter.hasNext()) {
      if(domainTypeURIs.contains(iter.next())) return true;
    }
    return false;
  }

  public boolean inRange(Set belongSet) {
    if(!rangeChecking()) return true; // not doing range checking
    Iterator iter = belongSet.iterator();
    while(iter.hasNext()) {
      if(rangeTypeURIs.contains(iter.next())) return true;
    }
    return false;
  }
  public String toString() {
    return this.selfURI;
  }
}